routes/web.php
<?php

use App\Http\Controllers\Admin\DashboardController as AdminDashboardController;
use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\Admin\StaffController as AdminStaffController;
use App\Http\Controllers\Admin\ProductController as AdminProductController;
use App\Http\Controllers\Admin\OrderController as AdminOrderController;
use App\Http\Controllers\User\DashboardController as UserDashboardController;
use App\Http\Controllers\User\OrderController as UserOrderController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes([
    'register' => false
]);

Route::prefix('admin')->name('admin.')->group(function(){
    // Admin Routes
    Route::middleware(['auth', 'role:admin'])->group(function(){
        Route::get('/', [AdminDashboardController::class, 'index'])->name('index');
    });

    // Admin & Staff Routes
    Route::middleware(['auth', 'role:admin,staff'])->group(function(){
        Route::prefix('user')->name('user.')->group(function(){
            Route::get('/', [AdminUserController::class, 'index'])->name('index');
            Route::get('/create', [AdminUserController::class, 'create'])->name('create');
            Route::post('/create', [AdminUserController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminUserController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminUserController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminUserController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminUserController::class, 'delete'])->name('delete');
        });

        Route::prefix('staff')->name('staff.')->group(function(){
            Route::get('/', [AdminStaffController::class, 'index'])->name('index');
            Route::get('/create', [AdminStaffController::class, 'create'])->name('create');
            Route::post('/create', [AdminStaffController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminStaffController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminStaffController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminStaffController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminStaffController::class, 'delete'])->name('delete');
        });

        Route::prefix('product')->name('product.')->group(function(){
            Route::get('/', [AdminProductController::class, 'index'])->name('index');
            Route::get('/create', [AdminProductController::class, 'create'])->name('create');
            Route::post('/create', [AdminProductController::class, 'store'])->name('store');
            Route::get('/detail/{id}', [AdminProductController::class, 'detail'])->name('detail');
            Route::get('/edit/{id}', [AdminProductController::class, 'edit'])->name('edit');
            Route::put('/edit/{id}', [AdminProductController::class, 'update'])->name('update');
            Route::delete('/delete', [AdminProductController::class, 'delete'])->name('delete');
        });

        Route::prefix('order')->name('order.')->group(function(){
            Route::get('/', [AdminOrderController::class, 'index'])->name('index');
            Route::get('/detail/{code}', [AdminOrderController::class, 'detail'])->name('detail');
            Route::post('/confirm', [AdminOrderController::class, 'confirm'])->name('confirm');
            Route::post('/reject', [AdminOrderController::class, 'reject'])->name('reject');
        });
    });
});

// User Routes
Route::middleware(['auth', 'role:user'])->group(function(){
    Route::get('/', [UserDashboardController::class, 'index'])->name('index');

    Route::prefix('order')->name('order.')->group(function(){
        Route::get('/', [UserOrderController::class, 'index'])->name('index');
        Route::get('/detail/{code}', [UserOrderController::class, 'detail'])->name('detail');
        Route::post('/add-to-cart', [UserOrderController::class, 'addToCart'])->name('addToCart');
        Route::get('/cart', [UserOrderController::class, 'cart'])->name('cart');
        Route::post('/checkout', [UserOrderController::class, 'checkout'])->name('checkout');
    });
});

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.bunny.net/css?family=Nunito" rel="stylesheet">

    <!-- Scripts -->
    @vite(['resources/sass/app.scss', 'resources/js/app.js'])
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                @guest
                    <a class="navbar-brand" href="{{ url('/') }}">
                        {{ config('app.name', 'Laravel') }}
                    </a>
                @else
                    @if(auth()->user()->isUser())
                    <a class="navbar-brand" href="{{ url('/') }}">
                        {{ config('app.name', 'Laravel') }}
                    </a>
                    @elseif(auth()->user()->isStaff())
                    <a class="navbar-brand" href="{{ url('/admin/user') }}">
                        {{ config('app.name', 'Laravel') }}
                    </a>
                    @else
                    <a class="navbar-brand" href="{{ url('/admin') }}">
                        {{ config('app.name', 'Laravel') }}
                    </a>
                    @endif
                @endguest
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav me-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ms-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif
                        @else
                            @switch(Auth::user()->role)
                                @case('admin')
                                    <li class="nav-item px-2">
                                        <a class="nav-link" href="{{ route('admin.order.index') }}">{{ __('Transaction') }}</a>
                                    </li>
                                    <li class="nav-item px-2">
                                        <a class="nav-link" href="{{ route('admin.product.index') }}">{{ __('Product') }}</a>
                                    </li>
                                    <li class="nav-item px-2">
                                        <a class="nav-link" href="{{ route('admin.staff.index') }}">{{ __('Staff') }}</a>
                                    </li>
                                    <li class="nav-item px-2" style="border-right: 1px solid #aaa;">
                                        <a class="nav-link" href="{{ route('admin.user.index') }}">{{ __('User') }}</a>
                                    </li>
                                    @break
                                @case('staff')
                                    <li class="nav-item px-2">
                                        <a class="nav-link" href="{{ route('admin.order.index') }}">{{ __('Transaction') }}</a>
                                    </li>
                                    <li class="nav-item px-2">
                                        <a class="nav-link" href="{{ route('admin.product.index') }}">{{ __('Product') }}</a>
                                    </li>
                                    <li class="nav-item px-2" style="border-right: 1px solid #aaa;">
                                        <a class="nav-link" href="{{ route('admin.user.index') }}">{{ __('User') }}</a>
                                    </li>
                                    @break
                                @case('user')
                                    <li class="nav-item px-2">
                                        <a class="nav-link" href="{{ route('order.index') }}">{{ __('Transaction') }}</a>
                                    </li>
                                    <li class="nav-item px-2" style="border-right: 1px solid #aaa;">
                                        <a class="nav-link" href="{{ route('order.cart') }}">{{ __('Cart') }}</a>
                                    </li>
                                    @break
                            @endswitch
                            <li class="nav-item dropdown ps-2">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-end" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>

    @yield('script')
</body>
</html>